#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

// Ejemplo de busqueda de maximo de vector con PThreads. NCC. ACAP. UGR. 2024

typedef struct{
	int idHilo;
	int numHilos;
	int* vector;
	int tamVector;
	pthread_mutex_t* mutex;
	int* resultadoGlobal;
} tarea;

void* cuerpoHilo(void* arg){
	tarea misDeberes = *((tarea*) arg);//Copiamos nuestra asignacion
	int maximoLocal = -1;
	int candidato = -1;
	for(int i = misDeberes.idHilo; i<misDeberes.tamVector; i+=misDeberes.numHilos){
		candidato = misDeberes.vector[i];
		if(candidato>maximoLocal){
			maximoLocal = candidato;
		}
	}
	pthread_mutex_lock(misDeberes.mutex);
	if(maximoLocal > *(misDeberes.resultadoGlobal) ){
		*(misDeberes.resultadoGlobal) = maximoLocal;
	}
	pthread_mutex_unlock(misDeberes.mutex);
	return 0;
}

void inicializarVector(int** pointToVec, int tam){
	*pointToVec = malloc(sizeof(int)*tam);
	int* vec = *pointToVec;//Esto es como hacer un "alias", por comodidad

	srand(time(0));
	for(int i = 0; i<tam; i++){
		vec[i] = rand() % 100; //Enteros de 0 a 99
	}

	vec[rand() % tam] = 100; // Ponemos un maximo al azar
}

int main(int argc, char* argv[]){
	if(argc!=3){
		printf("Uso: ./programa tamVector numHilos\n");
	}else{
		int tamVector = atoi(argv[1]);
		int nHilos = atoi(argv[2]);
		int* vector = 0;
		inicializarVector(&vector, tamVector);
		int resultado = -1;

		pthread_t* hilos = malloc(sizeof(pthread_t)*nHilos);
		pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER; // Un mutex para "gobernarlos" a todos
		tarea* deberes = malloc(sizeof(tarea)*nHilos);

		for(int i = 0; i<nHilos; i++){
			deberes[i].idHilo = i;
			deberes[i].numHilos = nHilos;
			deberes[i].vector = vector;
			deberes[i].tamVector = tamVector;
			deberes[i].mutex = &mutex;
			deberes[i].resultadoGlobal = &resultado;
			pthread_create(&(hilos[i]), 0, cuerpoHilo, &(deberes[i]));
		}
		//-----------------------------
		for(int i = 0; i<nHilos; i++){
			pthread_join(hilos[i], 0);
		}
		printf("Resultado: %d\n", resultado);

		free(hilos);
		free(deberes);
		free(vector);
	}
	return 0;
}
